/**
 *
 * *** Copyright Notice ***
 *
 * BeStMan Copyright (c) 2010, The Regents of the University of California, 
 * through Lawrence Berkeley National Laboratory (subject to receipt of any 
 * required approvals from the U.S. Dept. of Energy).  This software was 
 * developed under funding from the U.S. Department of Energy and is 
 * associated with the Berkeley Lab Scientific Data Management Group projects.
 * All rights reserved.
 * 
 * If you have questions about your rights to use or distribute this software, 
 * please contact Berkeley Lab's Technology Transfer Department at TTD@lbl.gov.
 * 
 * NOTICE.  This software was developed under funding from the 
 * U.S. Department of Energy.  As such, the U.S. Government has been granted 
 * for itself and others acting on its behalf a paid-up, nonexclusive, 
 * irrevocable, worldwide license in the Software to reproduce, prepare 
 * derivative works, and perform publicly and display publicly.  
 * Beginning five (5) years after the date permission to assert copyright is 
 * obtained from the U.S. Department of Energy, and subject to any subsequent 
 * five (5) year renewals, the U.S. Government is granted for itself and others
 * acting on its behalf a paid-up, nonexclusive, irrevocable, worldwide license
 * in the Software to reproduce, prepare derivative works, distribute copies to
 * the public, perform publicly and display publicly, and to permit others to
 * do so.
 *
*/
/**
 *
 * Email questions to SRM@LBL.GOV
 * Scientific Data Management Research Group
 * Lawrence Berkeley National Laboratory
 * http://sdm.lbl.gov/bestman
 *
*/

package gov.lbl.srm.client.wsdl;
 
import java.util.*;
import gov.lbl.srm.StorageResourceManager.*;

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//PathDetail
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public class PathDetail {

 private java.lang.String path;
 private gov.lbl.srm.StorageResourceManager.TReturnStatus status;
 private org.apache.axis.types.UnsignedLong size;
 private java.util.Calendar createdAtTime;
 private java.util.Calendar lastModificationTime;
 private gov.lbl.srm.StorageResourceManager.TFileStorageType fileStorageType;
 private gov.lbl.srm.StorageResourceManager.TRetentionPolicyInfo retentionPolicyInfo;
 private gov.lbl.srm.StorageResourceManager.TFileLocality fileLocality;
 private gov.lbl.srm.StorageResourceManager.ArrayOfString arrayOfSpaceTokens;
 private gov.lbl.srm.StorageResourceManager.TFileType type;
 private java.lang.Integer lifetimeAssigned;
 private java.lang.Integer lifetimeLeft;
 private gov.lbl.srm.StorageResourceManager.TUserPermission ownerPermission;
 private gov.lbl.srm.StorageResourceManager.TGroupPermission groupPermission;
 private gov.lbl.srm.StorageResourceManager.TPermissionMode otherPermission;
 private java.lang.String checkSumType;
 private java.lang.String checkSumValue;
 private PathDetail[] subPath;


 
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// constructor
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public PathDetail () {
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setSubPath
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setSubPath (PathDetail[] subPath) { 
   this.subPath = subPath;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getSubPath
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public PathDetail[] getSubPath () { 
   return subPath;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setOtherPermission
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setOtherPermission (TPermissionMode otherPermission) { 
  this.otherPermission = otherPermission;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getOtherPermission
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public TPermissionMode getOtherPermission () { 
  return otherPermission;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setGroupPermission
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setGroupPermission (TGroupPermission groupPermission) { 
  this.groupPermission = groupPermission;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getGroupPermission
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public TGroupPermission getGroupPermission () { 
  return groupPermission;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setOwnerPermission
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setOwnerPermission (TUserPermission ownerPermission) { 
  this.ownerPermission = ownerPermission;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getOwnerPermission
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public TUserPermission getOwnerPermission () { 
  return ownerPermission;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setCheckSumValue
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setCheckSumValue (String checkSumValue) { 
  this.checkSumValue = checkSumValue;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getCheckSumValue
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public String getCheckSumValue () { 
  return checkSumValue;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setCheckSumType
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setCheckSumType (String checkSumType) { 
  this.checkSumType = checkSumType;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getCheckSumType
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public String getCheckSumType () { 
  return checkSumType;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setLifeTimeLeft
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setLifeTimeLeft (Integer lifetimeLeft) { 
  this.lifetimeLeft = lifetimeLeft;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getLifetimeLeft
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public Integer getLifeTimeLeft () { 
  return lifetimeLeft;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setLifetimeAssigned
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setLifeTimeAssigned (Integer lifetimeAssigned) { 
  this.lifetimeAssigned = lifetimeAssigned;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getLifetimeAssigned
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public Integer getLifeTimeAssigned () { 
  return lifetimeAssigned;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setFileType
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setFileType (TFileType type) { 
 this.type = type;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getFileType
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public TFileType getFileType () { 
  return type;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setArrayOfSpaceTokens
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setArrayOfSpaceTokens (ArrayOfString arrayOfSpaceTokens) { 
  this.arrayOfSpaceTokens = arrayOfSpaceTokens;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getArrayOfSpaceTokens
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public ArrayOfString getArrayOfSpaceTokens () { 
  return arrayOfSpaceTokens;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setFileLocality
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setFileLocality (TFileLocality fileLocality) { 
   this.fileLocality = fileLocality;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getFileLocality
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public TFileLocality getFileLocality () { 
   return fileLocality;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setRetentionPolicyInfo
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setRetentionPolicyInfo(TRetentionPolicyInfo retentionPolicyInfo) { 
   this.retentionPolicyInfo = retentionPolicyInfo;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getRetentionPolicyInfo
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public TRetentionPolicyInfo getRetentionPolicyInfo() { 
   return retentionPolicyInfo;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setFileStorageType
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setFileStorageType(TFileStorageType fileStorageType) { 
   this.fileStorageType = fileStorageType;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getFileStorageType
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public TFileStorageType getFileStorageType() { 
   return fileStorageType;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setLastModificationTime
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setLastModificationTime(java.util.Calendar lastModificationTime) { 
   this.lastModificationTime = lastModificationTime;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getLastModificationTime
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public java.util.Calendar getLastModificationTime() { 
   return lastModificationTime;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setCreatedAtTime
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setCreatedAtTime(java.util.Calendar createdAtTime) { 
   this.createdAtTime = createdAtTime;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getCreatedAtTime
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public java.util.Calendar getCreatedAtTime() { 
   return createdAtTime; 
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setSize
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setSize(org.apache.axis.types.UnsignedLong size) { 
  this.size = size;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getSize
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public org.apache.axis.types.UnsignedLong getSize() {
  return size;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setPath
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setPath(String path) {
  this.path = path;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getPath
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public String getPath() {
  return path;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setStatus
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setStatus(TReturnStatus status) {
  this.status = status;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getStatus
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public TReturnStatus getStatus() {
   return status;
}

}
