/**
 *
 * *** Copyright Notice ***
 *
 * BeStMan Copyright (c) 2010, The Regents of the University of California, 
 * through Lawrence Berkeley National Laboratory (subject to receipt of any 
 * required approvals from the U.S. Dept. of Energy).  This software was 
 * developed under funding from the U.S. Department of Energy and is 
 * associated with the Berkeley Lab Scientific Data Management Group projects.
 * All rights reserved.
 * 
 * If you have questions about your rights to use or distribute this software, 
 * please contact Berkeley Lab's Technology Transfer Department at TTD@lbl.gov.
 * 
 * NOTICE.  This software was developed under funding from the 
 * U.S. Department of Energy.  As such, the U.S. Government has been granted 
 * for itself and others acting on its behalf a paid-up, nonexclusive, 
 * irrevocable, worldwide license in the Software to reproduce, prepare 
 * derivative works, and perform publicly and display publicly.  
 * Beginning five (5) years after the date permission to assert copyright is 
 * obtained from the U.S. Department of Energy, and subject to any subsequent 
 * five (5) year renewals, the U.S. Government is granted for itself and others
 * acting on its behalf a paid-up, nonexclusive, irrevocable, worldwide license
 * in the Software to reproduce, prepare derivative works, distribute copies to
 * the public, perform publicly and display publicly, and to permit others to
 * do so.
 *
*/
/**
 *
 * Email questions to SRM@LBL.GOV
 * Scientific Data Management Research Group
 * Lawrence Berkeley National Laboratory
 * http://sdm.lbl.gov/bestman
 *
*/

package gov.lbl.srm.client.wsdl;
 
import java.util.*;
import gov.lbl.srm.StorageResourceManager.*;

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//SRMRequestSummary
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public class SRMRequestSummary {

public TReturnStatus status; 
private TRequestSummary summary;
public String requestId;
public int totalFiles;
public int completedFiles;
public int waitingFiles;
public int failedFiles;

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//SRMRequestSummary --- constructor
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public SRMRequestSummary () {
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setSummaryArray
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setSummaryArray(TRequestSummary summary) {
   this.summary = summary; 
   if(summary.getTotalNumFilesInRequest() != null) {
      totalFiles = summary.getTotalNumFilesInRequest().intValue();
   }
   if(summary.getNumOfCompletedFiles() != null) {
      completedFiles = summary.getNumOfCompletedFiles().intValue();
   }
   if(summary.getNumOfWaitingFiles() != null) {
      waitingFiles = summary.getNumOfWaitingFiles().intValue();
   }
   if(summary.getNumOfFailedFiles() != null) {
      failedFiles = summary.getNumOfFailedFiles().intValue();
   }
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getSummaryArray
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public TRequestSummary getSummaryArray() {
   return summary;
}

}
